package svghexajongg;

/**
 *
 * @author uja
 * Engine: SVGMahJongg
 * 3.12.11: Tilehöhe geschrumpft, um Sichtbarkeit der Schichten (z) zu erhöhen
 * 17. - 20.12.11: 2 zusätzliche Tilesets, Hooks für 2 weitere (erstellen nach tileset0-Muster, nur noch ins Jar kopieren)
 * 
 * todo:
 * weitere Tilesets, mehr Bretter
 *
 * Achtung: Salamander kann kein Clipping und kein radialGradient (Lösung über Pattern)
 *
 */
import java.awt.BorderLayout;
import java.awt.Color;
import javax.swing.*;
import java.awt.event.*;
import java.awt.Dimension;
import java.util.HashMap;
import common.loadsave;
import common.ffilter;
import common.filereq;
import common.sound;

public class Main
{ final static String titel="SVG-HexaJongg";
  final static String lbr = System.getProperty("line.separator");
  final static String commtitel[] = { "DATEI","OPTIONS","INFO" };
  final static String commands[]  = { "NEW","SOLVABLE","RESTART","LOADGAME","SAVEGAME","UNDO","TURN","SHOWMOVE","REST","MIX","QUIT","LEVEL","SAVEOPT","HELP","ABOUT" };
  final static String subcomms[]  = { "TSET0","TSET1","TSET2","TSET3","TSET4","DBLAU","DROT","SAND","MOOS","WHITE","BLACK","LANG0","LANG1" };
  final static String cbcomms[]   = { "SOUND","SHOWFREE" };
  final static int shortcut[]={ KeyEvent.VK_N,KeyEvent.VK_L,KeyEvent.VK_R,-1,-1,KeyEvent.VK_B,KeyEvent.VK_T,-1,-1,KeyEvent.VK_M,KeyEvent.VK_Q,
                                -1,KeyEvent.VK_S,KeyEvent.VK_H,KeyEvent.VK_A };
  final static String wavliste[]  = { "klick0.wav","klick1.wav","undo.wav","drago.wav" };

  static JLabel startupmess=null;
  // Voreinstellungen der INI:
  static int bgid=0,tileid=0,langid=0,sx=800,sy=600;
  static boolean loesbar=false,mit_sound=false,showfree=false;
  static String patternid="";

  static JFrame my_frame;
  static svgpanel my_panel;
  static game my_game=new game();
  static JMenuBar my_menu;
  static JMenu menu[]=new JMenu[3];
  static JMenuItem mitem[]=new JMenuItem[commands.length];
  static JRadioButtonMenuItem rbitem[]=new JRadioButtonMenuItem[subcomms.length];
  static JCheckBoxMenuItem cbitem[]=new JCheckBoxMenuItem[cbcomms.length];
  static ButtonGroup rbutt[]=new ButtonGroup[3];

  // Sprachmodul:
  static String langtext[];   // Textkennungen
  public static HashMap<String,String> langdef=new HashMap<String,String>();

// Verbindung zu anderen Modulen:
  static loadsave fh = new loadsave();
  static ffilter ff;
  static filereq fq=new filereq();
  static sound my_sound=new sound("/sounds/",wavliste);

  // Interfaces:
  static ActionListener alist = new ActionListener()     { public void actionPerformed(ActionEvent e) { buttonklick(e); } };
  static MouseAdapter mausdap=new MouseAdapter()         { @Override public void mouseReleased(MouseEvent e) { mausklick(e.getX(),e.getY()); } };
  static MouseMotionAdapter mausmovedap=new MouseMotionAdapter() { @Override public void mouseMoved(MouseEvent e) { mausmove(e.getX(),e.getY());} };
  static ComponentAdapter compdap=new ComponentAdapter() { @Override public void componentResized(ComponentEvent e) { resize(); } };

  // extra, damit es auch ohne Event aufgerufen werden kann:
  public static void mausklick(int mx,int my) { my_panel.set_screen(0); my_game.klick(my_panel.calc_maus(mx, my)); }
  public static void mausmove(int mx,int my)  { my_panel.set_aktstein(my_panel.calc_maus(mx, my)); }
  public static void resize()
  { int fx = (int) my_frame.getContentPane().getBounds().getWidth();
    int fy = (int) my_frame.getContentPane().getBounds().getHeight();
    my_panel.set_size(fx,fy);
  }

  public static void main(String[] args)
  {
    // Notfenster mit Bildchen oder Ladehinweis, als JLabel implementiert.
    startupmess = new JLabel("Starting "+titel+", please wait!", JLabel.CENTER);
    startupmess.setForeground(Color.YELLOW);

    // Frame aufbauen mit Icon:
    my_frame=new JFrame(titel);
    java.net.URL URL2 = Main.class.getResource("/bilder/mjicon.png");
    if (URL2 != null) my_frame.setIconImage(java.awt.Toolkit.getDefaultToolkit().getImage(URL2));

    my_frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    my_frame.setMinimumSize(new Dimension(480,360));
    my_frame.setLayout(new BorderLayout());
    my_frame.getContentPane().setBackground(Color.BLACK);
    my_frame.getContentPane().add(startupmess);
    my_frame.setVisible(true);

	// ab hier nur den EDT für weitere Swing-Komonenten verwenden:
    javax.swing.SwingUtilities.invokeLater(new Runnable()
    { public void run()
      { mach_menu();
	// maussensitives Spielfeld erstellen
        my_panel=new svgpanel();
	my_panel.addMouseListener(mausdap);           // meldet Mausklicks ins Spielfeld
	my_panel.addMouseMotionListener(mausmovedap); // meldet Mausbewegungen im Spielfeld
	my_frame.addComponentListener(compdap);       // meldet, wenn die Fenstergröße sich geändert hat
	my_frame.setJMenuBar(my_menu);                // Menu einhängen
        load_opt();
        set_select();
	my_frame.setPreferredSize(new Dimension(sx,sy)); // Größe des Spielfeldes vorgeben
	my_frame.getContentPane().remove(startupmess);   // Laden ist fertig, weg mit dem Startlabel!
	my_frame.add(my_panel);                          // Spielfeld einhängen
	my_frame.pack();                                 // berechnet GUI neu und stellt alles dar, leider ungenau
        resize();                                        // deshalb hier nochmal berechnen
        neu();
	// ab hier übernehmen die Events die Steuerung
      }
    }
    );

  }

  public static void popup(String t)
  { String out=t.replace("<br>",lbr);
    JOptionPane.showMessageDialog(null,out,"Info:",JOptionPane.INFORMATION_MESSAGE);
  }

  static void htmpopup(String t)
  { JEditorPane jep=new JEditorPane("text/html",t);
    JScrollPane jsp =new JScrollPane(jep);
    jep.setPreferredSize(new Dimension(580,480));
    jep.select(0,0); // muss vor's Einbinden!
    jsp.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
    jsp.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
    JOptionPane.showMessageDialog(null,jsp,"Info:",JOptionPane.INFORMATION_MESSAGE);
    JScrollBar scroll=jsp.getVerticalScrollBar();
    scroll.setValue(scroll.getMinimum());
  }

  static void mach_menu()
  {  my_menu=new JMenuBar();
     int i,k;
     // erst mal alle Menus, MenuItems und Button Groups sowue Checkboxen hintereinanderweg erzeugen:
     for (i=0; i <commtitel.length; i++) { menu[i]=new JMenu(commtitel[i]); my_menu.add(menu[i]); }
     for (i=0; i<commands.length; i++)
     { mitem[i]=new JMenuItem(commands[i]);
       if (shortcut[i]>=0) mitem[i].setAccelerator(KeyStroke.getKeyStroke(shortcut[i],InputEvent.CTRL_MASK));
       mitem[i].addActionListener(alist);
       mitem[i].setActionCommand(commands[i]);
     }
     for (i=0; i< cbitem.length; i++)
     { cbitem[i]=new JCheckBoxMenuItem(cbcomms[i],false);
       cbitem[i].addActionListener(alist);
       cbitem[i].setActionCommand(cbcomms[i]);
     }
     for (i=0; i< subcomms.length; i++)
     { rbitem[i] = new JRadioButtonMenuItem(subcomms[i]);
       rbitem[i].addActionListener(alist);
       rbitem[i].setActionCommand(subcomms[i]);
     }

     // Buttongroups erstellen und items verteilen:
     for (i=0; i< rbutt.length; i++) rbutt[i]=new ButtonGroup();
     // 5 Steinsets, 6 Hintergründe und 2 Sprachen auf die 3 Buttongroups verteilen:
     k=0;
     for (i=0; i<5; i++) { rbutt[0].add(rbitem[k]); k++; }
     for (i=0; i<6; i++) { rbutt[1].add(rbitem[k]); k++; }
     for (i=0; i<2; i++) { rbutt[2].add(rbitem[k]); k++; }

     // fertige MenuItems an ihre Menus einhängen, mit Trennern ein bisschen ordnen:
     for (i=0; i<11; i++)
     { menu[0].add(mitem[i]);
       if ((i==4) || (i==9)) menu[0].addSeparator(); // Trenner nach Bretterzeugung und vor Quit
     }
     menu[1].add(mitem[11]); // pattern laden
     menu[1].addSeparator();
     for (i=0; i<cbitem.length; i++) menu[1].add(cbitem[i]); // Soundon/off
     menu[1].addSeparator();
     
     for (i=0; i<rbitem.length; i++)
     { menu[1].add(rbitem[i]);
       if ((i==4) || (i==10))  menu[1].addSeparator(); // Trenner nach den 3 Buttongroups
     }
     menu[1].addSeparator();
     menu[1].add(mitem[12]); // Optionen speichern

     for (i=13; i< mitem.length; i++) menu[2].add(mitem[i]); // Info-Menu
  }

  static void play(int nr) { if (mit_sound) my_sound.play_sound(nr); }

// -----------------------------------------------------------------------------------------------------
  static void set_lang(int nr)
  { int i;
    langid=nr;
    String rec[]=fh.get_ressourcelines("/texte/lang"+nr+".def");
    String temp[]=new String[2];
    for (i=0; i<rec.length; i++) { temp=rec[i].split("="); langdef.put(temp[0],temp[1]); }
    for (i=0; i<commtitel.length; i++)  menu[i].setText(langdef.get(commtitel[i]));
    for (i=0; i<commands.length; i++)  mitem[i].setText(langdef.get(commands[i]));
    for (i=0; i<subcomms.length; i++) rbitem[i].setText(langdef.get(subcomms[i]));
    for (i=0; i<cbcomms.length; i++)  cbitem[i].setText(langdef.get(cbcomms[i]));
  }

  static void set_select()
  { for (int i=0; i<rbutt.length; i++) rbutt[i].clearSelection();
    rbitem[tileid].setSelected(true);
    rbitem[bgid+5].setSelected(true);
    rbitem[langid+11].setSelected(true);
    cbitem[0].setSelected(mit_sound);
    cbitem[1].setSelected(showfree);
  }
// -----------------------------------------------------------------------------------------------------
   static public void buttonklick(ActionEvent e)
   {
    int i,kommando=-1;
    for (i=0; i<commands.length; i++) if (commands[i].equals(e.getActionCommand())) kommando = i;
    if (kommando<0) for (i=0; i<subcomms.length; i++) if (subcomms[i].equals(e.getActionCommand())) kommando = i+commands.length;
    if (kommando<0)  for (i=0; i<cbcomms.length; i++) if (cbcomms[i].equals(e.getActionCommand())) kommando = i+commands.length+subcomms.length;

    my_panel.set_screen(0);
    switch (kommando)
    { case 0: neu(); break;
      case 1: loesbar(); break;
      case 2: reset(); break;
      case 3: loadgame(); break;
      case 4: savegame(); break;

      case 5: undo(); break;
      case 6: turn(); break;
      case 7: showmoves(); break;
      case 8: rest(); break;
      case 9: zeige_lsg(); break;
      case 10: System.exit(0); break;

      case 11: set_patt(); break;
      case 12: save_opt(); break;
      case 13: htmpopup(fh.get_ressource(langdef.get("HELPFILE"))); break;
      case 14: popup(langdef.get("ABOUTINF")); break;
      case 15:
      case 16:
      case 17:
      case 18:
      case 19: set_tileset(kommando-15); break;
      case 20:
      case 21:
      case 22:
      case 23:
      case 24:
      case 25: set_background(kommando-20); break;
      case 26: set_lang(0); break;
      case 27: set_lang(1); break;
      case 28: toggle_sound(); break;
      case 29: toggle_showfree(); break;
    }
  }

  static void neu()   { loesbar=false; set_undobutt(false); mitem[9].setText(langdef.get("MIX")); my_game.neu(); }
  static void reset() { set_undobutt(false); my_game.restart(); }

  static void loadgame()
  {  if (fh.get_file("gamestor").isEmpty()) popup(langdef.get("NOGAMESAVED"));
     else
      { my_game.restore_status(fh.get_lines("gamestor"));
        set_undobutt(my_game.sliste.get_size()>0);
      }
  }
  static void savegame()  
  { fh.set_file("gamestor",my_game.backup_status());
    if (fh.get_file("gamestor").isEmpty()) popup(langdef.get("NOSAVE"));
    else  popup(langdef.get("GAMESAVED"));
  }

  static void turn()      { my_game.drehen(); }
  static void showmoves() { my_game.mach_zugliste(); }
  static void set_tileset(int nr) { tileid=nr; my_panel.set_tileset(tileid); }
  static void set_background(int nr) { bgid=nr; my_panel.set_bg(bgid); }
  static void toggle_sound() { mit_sound=!mit_sound; cbitem[0].setSelected(mit_sound); }
  static void toggle_showfree() { showfree=!showfree; cbitem[1].setSelected(showfree); }

  static void loesbar()   { loesbar=true; mitem[9].setText(langdef.get("SOLUTION")); my_game.mach_loesbar();}
  static void zeige_lsg() { if (loesbar) my_game.zeige_lsg(); else my_game.mischen(); }
  static void undo() { my_game.undo(); set_undobutt(my_game.sliste.get_size()>0); }
  static void rest() { my_panel.set_screen(1); } 
  static void set_undobutt(boolean flag) { if (flag) mitem[5].setText(langdef.get("UNDO")); else mitem[5].setText(""); }
  static void set_loadbutt() { if (fh.get_file("gamestor").isEmpty()) mitem[3].setText(""); else mitem[3].setText(langdef.get("LOADGAME")); }

// ------------------------------------------------------------------------------
  static void set_patt()
  { String filnam="";
    ff = new ffilter("pat","MahJongg Patterns");
    fq.set_params("Load Pattern",false);
    fq.set_selector("pat","MahJongg-Patterns");
    filnam=fq.openreq();
    if (filnam.equals("")) popup(langdef.get("STOPPED"));
    else { patternid=filnam; my_game.prepare_level(fh.get_lines(filnam)); my_game.neu(); }
  }
  
  static void load_opt()
  { String[] rec={""};
    rec = fh.get_lines("options.ini");
    if (rec.length>2)
    { String temp[]=new String[2];
      for (int i=0; i<rec.length; i++)
      { temp=rec[i].split("=");
        if (temp[0].equals("lang")) langid=Integer.parseInt(temp[1]);
        else if (temp[0].equals("pattern"))  patternid=temp[1];
        else if (temp[0].equals("background"))  bgid=Integer.parseInt(temp[1]);
        else if (temp[0].equals("tileset"))  tileid=Integer.parseInt(temp[1]);
        else if (temp[0].equals("sound"))  mit_sound=(Integer.parseInt(temp[1])==1);
        else if (temp[0].equals("hover"))  showfree=(Integer.parseInt(temp[1])==1);
        else if (temp[0].equals("sx"))  sx=Integer.parseInt(temp[1]);
        else if (temp[0].equals("sy"))  sy=Integer.parseInt(temp[1]);
      }
    }
    else popup("options.ini is missing!"+lbr+"Starting with standard values...");
    set_lang(langid);
    set_background(bgid);
    set_tileset(tileid);
    if (!patternid.equals("")) my_game.prepare_level(fh.get_lines(patternid));
    set_select();
    cleanup_tset();
  }

  static void save_opt()
  { String t="lang="+langid+lbr;
    int k=0;
    t=t+"pattern="+patternid+lbr;
    t=t+"background="+bgid+lbr;
    t=t+"tileset="+tileid+lbr;
    if (mit_sound) k=1; else k=0; t=t+"sound="+k+lbr;
    if (showfree) k=1; else k=0; t=t+"hover="+k+lbr;
    t=t+"sx="+my_frame.getWidth()+lbr;
    t=t+"sy="+my_frame.getHeight()+lbr;
    fh.set_file("options.ini",t);
    popup(langdef.get("OPTGESAVED"));
  }

  static void cleanup_tset()
  {
    for (int i=0; i<5; i++) if (langdef.get(subcomms[i]).equals("-")) { menu[1].remove(rbitem[i]); }
  }
 // ----------------------------------------------------------------------------


}
