package svghexajongg;
/**
 *
 * @author ujaso
 * Leckerchen: SVG-Grafik, Generierung lösbarer Bretter
 */

import javax.swing.*;
import javax.imageio.*;

import java.awt.*;
import java.awt.Graphics2D.*;
import java.awt.image.BufferedImage;
import java.io.*;
import java.net.URI;

import com.kitfox.svg.SVGUniverse;
import com.kitfox.svg.SVGDiagram;
import com.kitfox.svg.SVGException;

import common.loadsave;


public final class svgpanel extends JPanel
{
  final static int fxmax=32,fymax=24,fzmax=8; // von game bestimmen lassen
  final static int wxoff=100,wyoff=128,wbreite=100,whoehe=70,wdx=25,wdy=25,wdzx=0,wdzy=20,woverlap=0,rand=16;
  static int breite,hoehe,xoff=16,yoff=16,dx,dy,dzx=0,dzy=20,overlap,panelx=800,panely=600,screenid;
  static int sxmax=fxmax*wdx+fzmax*wdzx+2*wxoff,symax=fymax*wdy+fzmax*wdzy+2*wyoff;
  public static final long serialVersionUID=0;

  Thread refresh;     // war etwas schneller als ohne
  int aktstein=-1;    // Stein, über dem die Maus ist - Hovereffekte

  // SVG Parameter:
  int numpics=36;
  SVGUniverse   svgu  =new SVGUniverse();
  SVGDiagram    dia[] =new SVGDiagram[numpics];
  BufferedImage bild[]=new BufferedImage[numpics];
  Graphics2D    bg2[] =new Graphics2D[numpics];
  URI uri[]=new URI[numpics];
  Image alpha=my_trans(hole_ima("alpha.jpg"),0x070ffffff);  // Hintergrundabschattung, alpha reduziert auf 112
  Image drago=my_trans(hole_ima("drache0.jpg"),0x60ffffff);  // Endebild, alpha reduiert auf 96
  Color hili=new Color(255,255,255,64); // Schatten gewählter Stein
  Color show=new Color(0,0,0,64);   // Schatten des Steins, über dem die Maus ist
  Color schatten=new Color(0,0,0,96);
  Polygon sechseck = new Polygon();

  static Color bgcolor=new Color(0,0,64);
  Font font = new Font("arial",Font.BOLD,14);
  game p_game;

  public svgpanel()
  { setPreferredSize(new Dimension(1024,768));
    set_tileset(0);
    screenid=0;
    refresh=new Thread() // kein EDT-Thread!
    { @Override public void run()
      { while (refresh!=null)
        { repaint();
          try { Thread.sleep(100); } // 0.1s Sendepause
          catch (InterruptedException e) { break; }
        }
      }
    };
    refresh.start();
  }
  
   
  // Bilddarstellungen: ========================================================================
  @Override public void paintComponent(Graphics g) 
  { g.setColor(bgcolor);
    g.fillRect(0,0,panelx,panely);
    if (Main.my_game.rest>0) g.drawImage(alpha,0,0,panelx,panely,this); else g.drawImage(drago,0,28,panelx,panely-28,this);
    Graphics2D g2=(Graphics2D) g;
    g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
    g2.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING, RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
    g2.setFont(font);
    if (screenid==0) zeige_brett(g2); else zeige_reststeine(g2);
  }

  void zeige_brett(Graphics2D g)
  { int i,j,k,sx,sy;
    p_game=Main.my_game;
    g.setColor(Color.WHITE);
    g.drawString(Main.langdef.get("RESTSTEINE")+": "+p_game.rest+"         "+Main.langdef.get("ZEIT")+": "+p_game.zeit+"         "+p_game.messi,rand,24);
    g.setStroke(new BasicStroke(dx/5));
    
    for (i=0; i<p_game.cmax; i++)
    { k=p_game.pliste[i];
      if (p_game.stein[k].is_aktiv())
      { sx=p_game.stein[k].get_x()+rand;
        sy=p_game.stein[k].get_y()+rand;
        // Stein
        g.drawImage(bild[p_game.stein[k].get_typ()], sx, sy, this);
        if ((p_game.show_zugliste) && (p_game.zliste.in_liste(k) >= 0))
        {  g.setColor(Color.white);
           sechseck.translate(sx,sy);
           g.drawPolygon(sechseck);
           g.setColor(hili);
           g.fillPolygon(sechseck);
           sechseck.translate(-sx,-sy);
        }
        else if ((Main.showfree) && (aktstein == k) && (p_game.ist_frei(k)))
        {  g.setColor(hili);
           sechseck.translate(sx,sy);
           g.fillPolygon(sechseck);
           sechseck.translate(-sx,-sy);
        }
      }
    }
  }

  void zeige_reststeine(Graphics2D g)
  { int i,ix,iy,k;  
    g.setColor(Color.WHITE);
    g.drawString(Main.langdef.get("RESTSTEINE"),rand,24);
    p_game=Main.my_game;
    int deltax=dx*4;
    int deltay=dy*2;
    ix=rand;
    iy=2*rand;
    for (i=0; i<game.cmax; i++)
    { k=p_game.tliste[i];
      if (p_game.stein[k].is_aktiv())
      { g.drawImage(bild[p_game.stein[k].get_typ()],ix,iy,this);
        if (ix>(panelx-rand-2*deltax)) { ix=rand; iy=iy+deltay; } else ix=ix+deltax;
      }
    }
  }

   // --- Helferlein: -------------------------------------------------------------------------------------------------------
  public void set_screen(int nr) { screenid=nr; }
  public int get_screen() { return screenid; }
  public void set_aktstein(int nr) { aktstein=nr; }
  
  // den am weitesten oben liegenden Stein im Capture-Bereich nehmen:
  public int calc_maus(int ix, int iy)
  { int i,k=-1;
    p_game=Main.my_game;
    for (i=0; i<game.cmax; i++) if (p_game.stein[i].is_aktiv()) if (p_game.stein[i].geklickt(ix-rand,iy-rand))
    { if (k<0) k=i; else if (p_game.stein[i].get_iz()>p_game.stein[k].get_iz()) k=i;
    }
    return k;
  }

  final Image hole_ima(String filnam)
  { Image myima=null;
    try { myima=ImageIO.read(getClass().getResource("/bilder/"+filnam)); }
    catch(Exception e) { System.out.println(filnam+" not found or valid"); }
    return myima;
  }

  public void hole_bild(int id,String filnam)
  {
    loadsave fh=new loadsave();
    StringReader reader = new StringReader(fh.get_ressource(filnam));
    dia[id]=svgu.getDiagram(svgu.loadSVG(reader,"tile"+id));
    // uri[id]=dia[id].getXMLBase();
    reader.close();

  }

// ------------------------------------------------------------------------------------------------------------

  public void set_size(int ix,int iy)
  { int i=0;
    calc_size(ix,iy);
    for (i = 0; i < numpics; i++)
    { // System.out.println(i);
      try
      { bild[i] = new BufferedImage(breite,hoehe,BufferedImage.TRANSLUCENT);
        bg2[i]=(Graphics2D) bild[i].getGraphics();
        bg2[i].setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
        dia[i].setIgnoringClipHeuristic(true);
        dia[i].setDeviceViewport(new Rectangle(0,0,breite,hoehe));
        dia[i].render(bg2[i]);
      }
      catch(SVGException e) { System.out.println("Fehler bei Bild "+i); }
    }
    sechseck.reset();
    sechseck.addPoint(0,dy);
    sechseck.addPoint(dx,0);
    sechseck.addPoint(3*dx,0);
    sechseck.addPoint(4*dx,dy);
    sechseck.addPoint(3*dx,2*dy);
    sechseck.addPoint(dx,2*dy);
    sechseck.addPoint(0,dy);
  }

  public void calc_size(int ixmax, int iymax)
  {
    p_game=Main.my_game;
    panelx=ixmax; panely=iymax;
    int cxmax=p_game.get_xmax();
    int cymax=p_game.get_ymax();
    int czmax=p_game.get_zmax();
   
    sxmax=(cxmax+1)*wdx+czmax*wdzx+3*rand;
    symax=(cymax+1)*wdy+czmax*wdzy+3*rand;
    double fac=(double)(panelx)/sxmax;
    double facy=(double)(panely)/symax;
    if (fac>facy) fac=facy;
    breite=(int)(fac*wbreite);
    hoehe=(int)(fac*whoehe);
    dx=(int)(fac*wdx);
    dy=(int)(fac*wdy);
    dzx=(int)(fac*wdzx);
    dzy=(int)(fac*wdzy);
    overlap=(int)(fac*woverlap);
    xoff=(int)(fac*czmax*wdzx)+rand;
    yoff=(int)(fac*czmax*wdzy)+rand;
    for (int i=0; i<game.cmax; i++) p_game.stein[i].set_sizes(dx,dy,dzx,dzy);
  }
// ----------------------------------------------------------------------------------------------------------------

  public void set_bg(int id)
  { switch(id)
    { case 1:  bgcolor=new Color(64,0,0); break;
      case 2:  bgcolor=new Color(160,160,128); break;
      case 3:  bgcolor=new Color(64,96,32); break;
      case 4:  bgcolor=new Color(240,240,240); break;
      case 5:  bgcolor=new Color(0,0,0); break;
      default: bgcolor=new Color(0,0,64);
    }
  }

  public void set_tileset(int id)
  { if (svgu!=null) svgu.clear();
    String sid="/bilder/tileset"+id+"/tile"+id+"_";
    for (int i=0; i<numpics; i++) hole_bild(i,sid+i+".svg");
    set_size(panelx,panely);
  }


  // jpg statt png hält das jar klein, dann hier: jpg rein, png raus, Rest-Alpha: 96
  Image my_trans(Image in, int filter)
  { int i,j,w=in.getWidth(null),h=in.getHeight(null);
    BufferedImage ein=new BufferedImage(w,h,BufferedImage.TYPE_4BYTE_ABGR);
    BufferedImage ret=new BufferedImage(w,h,BufferedImage.TYPE_4BYTE_ABGR);
    Graphics2D gt=ein.createGraphics();
    gt.drawImage(in, 0, 0, this);
    for (j=0; j<h; j++) for (i=0; i<w; i++) ret.setRGB(i,j,(ein.getRGB(i,j)& filter)); // durchscheinend
    gt.dispose();
    return ret;
  }

}
